PROGRAM OttoRegine;
USES CRT,UtilScr,MouseDrv,Printer,Dos;

{ Dati per la grafica e per l'interfaccia utente }

CONST BORDERCOL   :byte= Black;
      BACKGRCOL   :byte= Black;
      FRAMECOLOR  :byte= White;
      INPUTCOL    :byte= LightGray;

      COLORBOX1   :byte= Blue;
      COLORBOX2   :byte= LightGray;
      QUEENCOL    :byte= White;
      NUMBERCOL   :byte= White;
      MSGCOLOR1   :byte= LightBlue; { Colore delle scritte non-messaggi }
      MSGCOLOR2   :byte= LightGray; { Colore dei "messaggi" }
      MSGCOLOR3   :byte= White;     { Colore del nome del solutore }

      GAD1COLOR_b :byte= Cyan;
      GAD1COLOR_t :byte= White;
      GAD2COLOR_b :byte= Green;
      GAD2COLOR_t :byte= White;
      GAD3COLOR_b :byte= Blue;
      GAD3COLOR_t :byte= White;
      GAD4COLOR_b :byte= Brown;
      GAD4COLOR_t :byte= White;
      GAD5COLOR_b :byte= Green;
      GAD5COLOR_t :byte= White;
      GAD6COLOR_b :byte= Magenta;
      GAD6COLOR_t :byte= White;
      GAD7COLOR_b :byte= Red;
      GAD7COLOR_t :byte= White;
      GAD8COLOR_b :byte= LightGray;
      GAD8COLOR_t :byte= White;

      IX1 = 4; { Coord. X scacchiera }
      IY1 = 1; { Coord. Y scacchiera }
      IH1 = 3; { Altezza casella     }
      IW1 = 7; { Larghezza casella   }

      MAXLENSTR = 18; { Lungh. max. dei nomi }

TYPE cmdtype = (ERR, NULLO, CELL, UNDO, REDO, CLEAR, QUIT, PR, PRALL, CLALL, QUIT2);
     strL = PACKED ARRAY [0..IW1-1] of char;

CONST FIRST = UNDO;  LAST = REDO; (* <- <- <- <- ************************)
      PREV  = CLEAR; SUC  = QUIT;

      SHOWFORBID :boolean= False;

      FORBIDCOL  :byte= Yellow;

      FORBIDSTR  : ARRAY [0..3] of char = ' '#250' ';
      REGINA     : ARRAY [0..IH1-1] of strL = ('      ',
                                               '  Q  ',
                                               '    ');

{ Dati per l'algoritmo di gioco }
TYPE coord   = 1..8;
     casella = RECORD
                  busy  : boolean;
                  forbid: boolean;
     END;
     Tboard  = ARRAY [coord, coord] of casella;
     Tsoluz  = ARRAY [coord] of char; { perche' tra array di caratteri si puo'}
     strN    = string[MAXLENSTR];     { effettuare un confronto diretto; in   }
     datastr = string[10];            { realta' sarebbe stato meglio cosi':   }
     entry   = RECORD                 { Tsoluz = ARRAY [coord] of coord       }
         config : Tsoluz;
         nome   : strN;
         data   : datastr;
     END;
     Tstream = FILE of entry;

VAR board  : Tboard;
    author : string[255];
    scelta : shortint;

{ "Prototipi" di procedure e funzioni }
PROCEDURE Beep(freq,duration:word); forward;
FUNCTION  itoa(i:integer):string; forward;
FUNCTION  LastPos(const s:string;c:char):byte; forward;
FUNCTION  ExeDir:string; forward;
PROCEDURE InitBoard(var board:Tboard); forward;
FUNCTION  Allowed(var board:Tboard; x,y:coord):boolean; forward;
FUNCTION  CountAvailable(var board:Tboard):word; forward;
PROCEDURE PutPiece(var board:Tboard; x,y:coord); forward;
PROCEDURE DrawQueen(px,py:coord); forward;
PROCEDURE ClearCell(px,py:coord); forward;
PROCEDURE DrawForbid(px,py:coord); forward;
PROCEDURE WriteBackg(col:byte; s:string); forward;
PROCEDURE WriteColor(col:byte; s:string); forward;
PROCEDURE DrawButton(x,y,col,backg:byte; s:string); forward;
PROCEDURE DrawBoard; forward;
PROCEDURE FlashWrite(const s:string); forward;
PROCEDURE DisplayMsg(const s1,s2,s3:string); forward;
PROCEDURE DrawPlayCommands; forward;
PROCEDURE DrawViewCommands; forward;
PROCEDURE Refresh(var board:Tboard); forward;
PROCEDURE PrintBoard(var board:Tboard;nome,data:string); forward;
PROCEDURE LoadPrefs(var retcode:integer); forward;
PROCEDURE SavePrefs(var retcode:integer); forward;
FUNCTION  Repl(c:char;n:byte):string; forward;
PROCEDURE Initialize; forward;
PROCEDURE WaitForEvent; forward;
PROCEDURE GetPlayCommand(var tp:cmdtype; var cx,cy:coord); forward;
PROCEDURE GetViewCommand(var tp:cmdtype); forward;
PROCEDURE PlotBox(x1,y1,x2,y2,bg,fg:byte;ch:char); forward;
PROCEDURE FullBox(x1,y1,x2,y2,col:byte); forward;
PROCEDURE Box3D(x1,y1,x2,y2,col:byte); forward;
PROCEDURE ClearInput; forward;
PROCEDURE Center(col:byte;const s:string); forward;
PROCEDURE Pulisci(a,b:byte); forward;
PROCEDURE IntroScreen; forward;
PROCEDURE SelectionScreen; forward;
PROCEDURE ArrayToMatrix(var soluz:Tsoluz; var board:Tboard); forward;
PROCEDURE ShowArchive; forward;
PROCEDURE Esci; forward;
PROCEDURE ExitScreen; forward;
PROCEDURE StartGame(var board:Tboard); forward;

{ Definizione delle procedure e delle funzioni }

PROCEDURE Beep(freq,duration:word);
BEGIN
     Sound(freq);
     Delay(duration*200);
     NoSound;
END;

FUNCTION itoa(i:integer):string;
VAR s : string;
BEGIN
     Str(i,s);
     itoa := s;
END;

FUNCTION LastPos(const s:string;c:char):byte;
VAR i,p : byte;
BEGIN
     p := 0;
     IF Length(s) > 0 THEN
        FOR i := 1 TO Length(s) DO
            IF s[i] = c THEN p := i;
     LastPos := p;
END;

FUNCTION ExeDir:string;
BEGIN
     ExeDir := Copy(ParamStr(0),1,LastPos(ParamStr(0),'\'));
END;

PROCEDURE InitBoard(var board:Tboard);
VAR i,j:coord;
BEGIN
     FOR i := 1 TO 8 DO
         FOR j := 1 TO 8 DO BEGIN
             board[i,j].busy  := False;
             board[i,j].forbid:= False;
         END;
END;

FUNCTION Allowed(var board:Tboard; x,y:coord):boolean;
BEGIN
     Allowed := not board[x,y].forbid;
END;

FUNCTION CountAvailable(var board:Tboard):word;
VAR result : word;
    i,j    : coord;
BEGIN
     result := 0;
     FOR i := 1 TO 8 DO
           FOR j := 1 TO 8 DO
                 IF Allowed(board,i,j) THEN Inc(result);
     CountAvailable := result;
END;

PROCEDURE PutPiece(var board:Tboard; x,y:coord);
VAR px,py,delta:coord;
BEGIN
     board[x,y].busy  := True;
     FOR px := 1 TO 8 DO board[px,y].forbid := True;
     FOR py := 1 TO 8 DO board[x,py].forbid := True;
     IF x<y THEN delta:=x-1 ELSE delta:=y-1; { delta = min(x-1,y-1) }
     px := x-delta; py := y-delta;
     WHILE (px <= 8) and (py <= 8) DO BEGIN
           board[px,py].forbid := True;
           px := px+1;
           py := py+1;
     END;
     IF (8-x)<(y-1) THEN delta:=8-x ELSE delta:=y-1; { delta = min(8-x,y-1) }
     px := x+delta; py := y-delta;
     WHILE (px >=1 ) and (py <= 8) DO BEGIN
           board[px,py].forbid := True;
           px := px-1;
           py := py+1;
     END;
END;

PROCEDURE DrawQueen(px,py:coord);
VAR x,y,i,j : byte;
    addr    : word;
BEGIN
     IF (px in [1..8]) and (py in [1..8]) THEN BEGIN
        x := (px-1)*IW1+(IX1-1);
        y := (py-1)*IH1+(IY1-1);
        FOR i := 0 TO IH1-1 DO
            FOR j := 0 TO IW1-1 DO BEGIN
                addr := ((y+i)*80+(x+j))*2;
                mem[$B800 : addr+1] := (mem[$B800 : addr+1] and 240)+QUEENCOL;
                mem[$B800 : addr  ] := ord(REGINA[i,j]);
            END;
     END;
END;

PROCEDURE ClearCell(px,py:coord);
VAR x,y,i,j,col : byte;
    addr        : word;
BEGIN
     IF (px in [1..8]) and (py in [1..8]) THEN BEGIN
        x := (px-1)*IW1+(IX1-1);
        y := (py-1)*IH1+(IY1-1);
        FOR i := 0 TO IH1-1 DO
            FOR j := 0 TO IW1-1 DO BEGIN
                addr := ((y+i)*80+(x+j))*2;
                mem[$B800 : addr+1] := (mem[$B800 : addr+1] and 240)+QUEENCOL;
                mem[$B800 : addr  ] := 32;
            END;
     END;
END;

PROCEDURE DrawForbid(px,py:coord);
VAR x,y,j,col : byte;
    addr      : word;
BEGIN
     IF (px in [1..8]) and (py in [1..8]) THEN BEGIN
        x := (px-1)*IW1+(IX1+1);
        y := (py-1)*IH1+(IY1);
        FOR j := 0 TO IW1-5 DO BEGIN
            addr := (y*80+(x+j))*2;
            mem[$B800 : addr+1] := (mem[$B800 : addr+1] and 240)+FORBIDCOL;
            mem[$B800 : addr] := ord(FORBIDSTR[j]);
        END;
     END;
END;

PROCEDURE WriteBackg(col:byte; s:string);
BEGIN
     TextBackground(col);
     Write(s);
END;

PROCEDURE WriteColor(col:byte; s:string);
BEGIN
     TextColor(col);
     Write(s);
END;

PROCEDURE DrawButton(x,y,col,backg:byte; s:string);
BEGIN
     TextBackground(BACKGRCOL);
     TextColor(backg);
     GotoXY(x,y);   Write('');
     GotoXY(x,y+2); Write('');
     TextBackground(backg);
     TextColor(col);
     GotoXY(x,y+1); Write(' ',s:4,' ');
END;

PROCEDURE DrawBoard;
CONST SPACESTR = '       ';
VAR i,j,k,y : byte;
BEGIN
     Mouse_Hide;
     BorderColor(BORDERCOL);
     TextBackground(BACKGRCOL);
     TextColor(QUEENCOL);
     ClrScr;
     y := IY1;
     FOR i := 1 TO 4 DO BEGIN
         FOR j := 1 TO IH1 DO BEGIN
             GotoXY(IX1,y);
             FOR k := 1 TO 4 DO BEGIN
                 WriteBackg(COLORBOX1,SPACESTR);
                 WriteBackg(COLORBOX2,SPACESTR);
             END;
             Inc(y);
         END;
         FOR j := 1 TO IH1 DO BEGIN
             GotoXY(IX1,y);
             FOR k := 1 TO 4 DO BEGIN
                 WriteBackg(COLORBOX2,SPACESTR);
                 WriteBackg(COLORBOX1,SPACESTR);
             END;
             Inc(y);
         END;
     END;
     TextColor(NUMBERCOL); TextBackGround(BACKGRCOL);
     FOR i := 1 TO 8 DO BEGIN
         GotoXY(2,IY1+IH1*(i-1)+(IH1 div 2));
         Write(i);
     END;
     GotoXY(IX1,8*IH1+1);
     FOR i := 1 TO 8 DO Write('   ':3,i:0,'   ');
     Mouse_Show;
END;

PROCEDURE FlashWrite(const s:string);
BEGIN
     IF s[1]='!' THEN BEGIN
        Flash(True);
        Write(Copy(s,2,Length(s)-1));
        Flash(False);
     END ELSE
        Write(s);
END;

PROCEDURE DisplayMsg(const s1,s2,s3:string);
CONST ROWSTART = 14;
      COLSTART = 63;
      OFS      = 0;
VAR oldX,oldY:byte;
BEGIN
     Mouse_Hide;
     oldX := WhereX; oldY := WhereY;
     FullBox(COLSTART,ROWSTART,COLSTART+15,ROWSTART+2,BACKGRCOL);
     TextBackground(BACKGRCOL); TextColor(MSGCOLOR2);
     GotoXY(COLSTART+OFS,ROWSTART); FlashWrite(s1);
     IF s2 <> '' THEN BEGIN
        GotoXY(COLSTART+OFS,ROWSTART+1);
        FlashWrite(s2);
     END;
     IF s3 <> '' THEN BEGIN
        GotoXY(COLSTART+OFS,ROWSTART+2);
        FlashWrite(s3);
     END;
     TextColor(INPUTCOL); Flash(True); Write('_'); Flash(False);
     GotoXY(oldX,oldY);
     Mouse_Show;
END;

PROCEDURE DrawPlayCommands;
BEGIN
     Mouse_Hide;
     TextBackground(BACKGRCOL); TextColor(MSGCOLOR1);
     GotoXY(62,02); Write(' Le otto regine ');
     TextColor(FRAMECOLOR);
     GotoXY(62,04); Write(' Comandi Ŀ');
     GotoXY(62,05); Write('                ');
     GotoXY(62,06); Write('');
     DrawButton(62,07,GAD1COLOR_t,GAD1COLOR_b,' UNDO ');
     DrawButton(72,07,GAD2COLOR_t,GAD2COLOR_b,' REDO ');
     DrawButton(62,10,GAD3COLOR_t,GAD3COLOR_b,' CLR! ');
     DrawButton(72,10,GAD4COLOR_t,GAD4COLOR_b,' EXIT ');
     TextBackground(BACKGRCOL); TextColor(FRAMECOLOR);
     GotoXY(62,13); Write(' Messaggi Ŀ');
     GotoXY(62,14); Write('                ');
     GotoXY(62,15); Write('                ');
     GotoXY(62,16); Write('                ');
     GotoXY(62,17); Write('');
     DisplayMsg('','','');
     Mouse_Show;
END;

PROCEDURE DrawViewCommands;
BEGIN
     Mouse_Hide;
     TextBackground(BACKGRCOL); TextColor(MSGCOLOR1);
     GotoXY(62,02); Write(' Le otto regine ');
     TextColor(FRAMECOLOR);
     GotoXY(62,04); Write(' Soluzione N. Ŀ');
     GotoXY(62,05); Write('                ');
     GotoXY(62,06); Write('');
     DrawButton(62,07,GAD1COLOR_t,GAD1COLOR_b,' FIRST');
     DrawButton(72,07,GAD2COLOR_t,GAD2COLOR_b,' LAST ');
     DrawButton(62,10,GAD3COLOR_t,GAD3COLOR_b,' PREV-');
     DrawButton(72,10,GAD4COLOR_t,GAD4COLOR_b,' SUCC+');
     DrawButton(62,13,GAD5COLOR_t,GAD5COLOR_b,' PRINT');
     DrawButton(72,13,GAD6COLOR_t,GAD6COLOR_b,'PR ALL');
     DrawButton(62,16,GAD7COLOR_t,GAD7COLOR_b,'CLRALL');
     DrawButton(72,16,GAD8COLOR_t,GAD8COLOR_b,' EXIT ');
     TextBackground(BACKGRCOL); TextColor(FRAMECOLOR);
     Mouse_Show;
END;

PROCEDURE Refresh(var board:Tboard);
VAR i,j:coord;
BEGIN
     Mouse_Hide;
     FOR i := 1 TO 8 DO
         FOR j := 1 TO 8 DO
             WITH board[i,j] DO BEGIN
                  IF (forbid and (not busy)) THEN BEGIN
                     IF SHOWFORBID THEN DrawForbid(i,j) ELSE ClearCell(i,j);
                  END ELSE IF ((not forbid) and (not busy)) THEN
                     ClearCell(i,j)
                  ELSE { sicuramente e' forbid & busy }
                     DrawQueen(i,j);
             END;
     Mouse_Show;
END;

PROCEDURE Disegna;
VAR x,y:byte;
    k:integer;
BEGIN
     ShowCursor;
     x:=0; y:=0;
     REPEAT
           gotoxy(1,1); write(x+1,' ',y+1,'  ');
           GotoXY(x+1,y+1);
           k := GetKey;
           CASE k OF
             cdSU      : IF (y > 0)  THEN Dec(y);
             cdGIU     : IF (y < 24) THEN Inc(y);
             cdSINISTRA: IF (x > 0)  THEN Dec(x);
             cdDESTRA  : IF (x < 79) THEN Inc(x);
             13        : BEGIN Inc(y); x := 0; END;
             1..12,
             14..26,
             28..255   : BEGIN mem[$B800 : (y*80+x)*2] := k; Inc(x); END;
           END;
     UNTIL k=27;
     HideCursor;
END;

PROCEDURE PrintBoard(var board:Tboard;nome,data:string);
VAR i,j : coord;
BEGIN
     WriteLn(Lst);
     WriteLn(Lst,' Soluzione di: ',nome);
     WriteLn(Lst,' Trovata il  : ',data);
     WriteLn(Lst);
     FOR i := 1 TO 8 DO BEGIN
         Write(Lst,'   ',i:0,' ');
         FOR j := 1 TO 8 DO BEGIN
             IF board[j,i].busy THEN Write(Lst,'Q') ELSE Write(Lst,'.');
             Write(Lst,' ');
         END;
         WriteLn(Lst);
     END;
{     WriteLn(Lst);}
     WriteLn(Lst,'     1 2 3 4 5 6 7 8');
     WriteLn(Lst);
END;

PROCEDURE LoadPrefs(var retcode:integer);
BEGIN
END;

PROCEDURE SavePrefs(var retcode:integer);
BEGIN
END;

FUNCTION  Repl(c:char;n:byte):string;
VAR s : string[255];
BEGIN
     FillChar(s,SizeOf(s),c);
     s[0] := chr(n);
     Repl := s;
END;

PROCEDURE Initialize;
VAR rc : integer;
BEGIN
     LoadPrefs(rc);
     scelta := 1;
     IF Mouse_Exists THEN BEGIN
        Mouse_Reset;
        Mouse_SetPos(42,10);
     END;
END;

PROCEDURE WaitForEvent;
VAR kp : boolean;
    ch : char;
BEGIN
     REPEAT UNTIL (Mouse_Down=0);
     REPEAT
           kp := KeyPressed;
           IF kp THEN ch := ReadKey;
     UNTIL not kp;
     REPEAT
           kp := KeyPressed;
     UNTIL kp or (Mouse_Down <> 0);
     IF kp THEN ch := ReadKey;
END;

PROCEDURE GetPlayCommand(var tp:cmdtype; var cx,cy:coord);
VAR ch   : char;
    kp   : boolean;
    x,y  : integer;
    md,i : byte;
    primotasto : boolean;
BEGIN
     primotasto := True;
     REPEAT
           tp := ERR;
           md := 0;
           REPEAT UNTIL Mouse_Down = 0;
           REPEAT
                 kp := KeyPressed;
                 md := Mouse_Down;
           UNTIL kp or (md <> 0);
           DisplayMsg('','','');
           IF (md <> 0) THEN BEGIN
              Mouse_GetPos(x,y);
              IF x in [62..69] THEN BEGIN
                 IF y in [07..09] THEN tp := UNDO;
                 IF y in [10..12] THEN tp := CLEAR; { CLR! }
              END;
              IF x in [72..79] THEN BEGIN
                 IF y in [07..09] THEN tp := REDO;
                 IF y in [10..12] THEN tp := QUIT;  { EXIT }
              END;
              IF (x in [04..59]) and (y in [1..24]) THEN BEGIN
                 tp := CELL;
                 x  := x-4;      y  := y-1;
                 x  := x div 7;  y  := y div 3;
                 cx := x+1;      cy := y+1;
              END;
           END;
           ch := #1;
           IF kp THEN ch := ReadKey;
           IF ch = #0 THEN BEGIN
              ch := ReadKey;
              ch := #0;
           END;
           ch := UpCase(ch);
           CASE ch OF
             #8,'U' : tp := UNDO;
                'R' : tp := REDO;
                'C' : tp := CLEAR;
                #27 : tp := QUIT;
           '1'..'8' : IF primotasto THEN BEGIN
                         primotasto := False;
                         tp := NULLO;
                         cy := ord(ch)-48;
                         TextColor(INPUTCOL);
                         Mouse_Hide; Write(cy:0,'- '#8); Mouse_Show;
                      END ELSE BEGIN
                         tp := CELL;
                         cx := ord(ch)-48;
                      END;
           END;
           IF (tp = ERR) THEN BEGIN
              IF md = 0 THEN BEGIN
                 DisplayMsg('   * ERRORE *','Tasto non valido',' '#8);
                 Beep(110,1);
              END ELSE BEGIN
                 DisplayMsg('   * ERRORE *','Mouse fuori','range');
                 Beep(110,1);
              END;
           END;
     UNTIL (tp <> NULLO) and (tp <> ERR);
END;

PROCEDURE GetViewCommand(var tp:cmdtype);
VAR ch   : char;
    kp   : boolean;
    x,y  : integer;
    md,i : byte;
BEGIN
     REPEAT
           tp := ERR;
           md := 0;
           REPEAT UNTIL Mouse_Down = 0;
           REPEAT
                 kp := KeyPressed;
                 md := Mouse_Down;
           UNTIL kp or (md <> 0);
           IF (md <> 0) THEN BEGIN
              Mouse_GetPos(x,y);
              IF x in [62..69] THEN BEGIN
                 IF y in [07..09] THEN tp := FIRST;
                 IF y in [10..12] THEN tp := PREV;
                 IF y in [13..15] THEN tp := PR;
                 IF y in [16..18] THEN tp := CLALL;
              END;
              IF x in [72..79] THEN BEGIN
                 IF y in [07..09] THEN tp := LAST;
                 IF y in [10..12] THEN tp := SUC;
                 IF y in [13..15] THEN tp := PRALL;
                 IF y in [16..18] THEN tp := QUIT2;
              END;
           END;
           ch := #1;
           IF kp THEN ch := ReadKey;
           IF ch = #0 THEN BEGIN
              ch := ReadKey;
              ch := #0;
           END;
           ch := UpCase(ch);
           CASE ch OF
            '1','F' : tp := FIRST;
                'L' : tp := LAST;
                '-' : tp := PREV;
                '+' : tp := SUC;
                'P' : tp := PR;
                'A' : tp := PRALL;
                'C' : tp := CLALL;
                #27 : tp := QUIT2;
           END;
           IF (tp = ERR) THEN Beep(110,1);
     UNTIL (tp <> ERR);
END;

PROCEDURE PlotBox(x1,y1,x2,y2,bg,fg:byte;ch:char);
VAR i,j : byte;
BEGIN
     TextBackground(bg);
     TextColor(fg);
     FOR i := 1 TO 2 DO
         FOR j := y1 TO y2 DO BEGIN
             IF i=1 THEN GotoXY(x1,j) ELSE GotoXY(x2,j);
             Write(ch);
         END;
     GotoXY(x1,y1); Write(Repl(ch,x2-x1+1));
     GotoXY(x1,y2); Write(Repl(ch,x2-x1+1));
END;

PROCEDURE FullBox(x1,y1,x2,y2,col:byte);
VAR t,whx,why : byte;
    wmin,wmax : word;
BEGIN
     t := TextAttr;
     wmin := WindMin; wmax := WindMax;
     whx  := WhereX;  why  := WhereY;
     Window(x1,y1,x2,y2);
     TextBackground(col);
     ClrScr;
     TextAttr := t;
     WindMin := wmin; WindMax := wmax;
     GotoXY(whx,why);
END;

PROCEDURE Box3D(x1,y1,x2,y2,col:byte);
BEGIN
     FullBox(x1+2,y1+1,x2+2,y2+1,Black);
     FullBox(x1,y1,x2,y2,col);
END;

PROCEDURE ClearInput;
BEGIN
     TextColor(INPUTCOL);
     FullBox(63,5,78,5,BACKGRCOL);
     GotoXY(64,5);
END;

PROCEDURE Center(col:byte;const s:string);
VAR t : byte;
BEGIN
     t := (80-Length(s)) div 2;
     GotoXY(t+1,WhereY);
     TextColor(col); Write(s);
END;

PROCEDURE Pulisci(a,b:byte);
BEGIN
     Window(5,a,76,b);
     TextBackground(LightGray); ClrScr;
     Window(1,1,80,25);
END;

PROCEDURE IntroScreen;
CONST COL  = Blue;
      COL2 = Yellow;
BEGIN
     TextBackground(LightGray);
     IF scelta = 1 THEN BEGIN
        ClrScr;
        PlotBox(3,2,78,24,LightGray,Red,#219);
        PlotBox(4,2,77,24,LightGray,Red,#219);
     END
     ELSE Pulisci(3,23);
     GotoXY(1,06); Center(COL2,'                                                ');
     GotoXY(1,07); Center(COL2,'                                                ');
     GotoXY(1,08); Center(COL2,'                                                ');
     GotoXY(1,09); Center(COL2,'                                                  ');
     GotoXY(1,10); Center(COL2,'                                                ');
     GotoXY(1,11); Center(COL2,'                                            ');
     GotoXY(1,12); Center(COL2,'                                        ');
     GotoXY(1,04); Center(LightCyan,'Written by');
     GotoXY(1,06); Center(COL,'            ');
     GotoXY(1,07); Center(COL,'                           ');
     GotoXY(1,08); Center(COL,'                 ');
{    GotoXY(1,09); Center(COL,'                                     ');}
     GotoXY(1,10); Center(COL,'       ');
     GotoXY(1,11); Center(COL,'           ');
     GotoXY(1,12); Center(COL,'         ');
     GotoXY(31,14); TextColor(LightCyan); Write('Francesco Sblendorio');
END;

PROCEDURE SelectionScreen;
VAR c       : char;
    m,md,i  : byte;
    err,x,y : integer;
    kp      : boolean;
BEGIN
     TextBackground(LightGray);
     GotoXY(32,17); WriteColor(Blue,'Fai la tua scelta');
     TextColor(DarkGray);
     GotoXY(26,19); Write('Comincia il gioco');
     GotoXY(26,20); Write('Visualizza le soluzioni trovate');
     GotoXY(26,21); Write('Esci');
     TextColor(White);
     FOR i := 1 TO 3 DO BEGIN
         GotoXY(23,18+i);
         Write(i,'.');
     END;
     Mouse_Show;
     m := 0;
     md := 0;
     WHILE (m<1) or (m>3) DO BEGIN
           IF Mouse_Exists THEN REPEAT UNTIL Mouse_Down = 0;
           REPEAT
                 kp := KeyPressed;
                 IF Mouse_Exists THEN md := Mouse_Down;
           UNTIL kp or (md <> 0);
           IF Mouse_Exists and (md <> 0) THEN BEGIN
              Mouse_GetPos(x,y);
              IF x in [22..57] THEN
                 FOR i := 1 TO 5 DO
                     IF y = 18+i THEN c := chr(48+i);
           END;
           IF kp THEN c := UpCase(ReadKey);
           Val(c,m,err);
           IF c = #13 THEN m := 1;
           IF c = #27 THEN m := 3;
     END;
     scelta := m;
     Mouse_Hide;
END;

PROCEDURE ArrayToMatrix(var soluz:Tsoluz; var board:Tboard);
VAR i:coord;
BEGIN
     InitBoard(board);
     FOR i := 1 TO 8 DO
         PutPiece(board,ord(soluz[i]),i);
END;

PROCEDURE ShowArchive;
VAR tot,cur : word;
    tp      : cmdtype;
    stream  : Tstream;
    iores   : integer;
    item    : entry;
    board   : Tboard;
BEGIN
     scelta := 1;
     DrawBoard;
     DrawViewCommands;
     TextColor(INPUTCOL); TextBackground(BACKGRCOL);
     ClearInput;
     GotoXY(64,5);
     Mouse_Show;
     ShowCursor;
     Assign(stream, ExeDir+'8REGINE.DAT');
     {$I-}
     Reset(stream);
     {$I+}
     iores := IOResult;
     IF iores = 2 THEN BEGIN  { FILE NOT FOUND }
        Mouse_Hide;
        GotoXY(63,5);
        Flash(True); Write('No soluzioni'); Flash(False);
        Mouse_Show;
        Beep(110,1);
        WaitForEvent;
     END ELSE IF iores = 0 THEN BEGIN
        tot := FileSize(stream);
        cur := 1;
        Read(stream,item);
        ArrayToMatrix(item.config,board);
        REPEAT
              HideCursor;
              Mouse_Hide;
              Refresh(board);
              TextColor(MSGCOLOR1);
              GotoXY(58+IX1,19); Write('N.',cur:2,' - trovata da:');
              TextColor(MSGCOLOR3); TextBackground(COLORBOX1);
              GotoXY(58+IX1,20); Write(Copy(item.nome+Repl(' ',MAXLENSTR),1,
                                                             MAXLENSTR));
              TextColor(MSGCOLOR1); TextBackground(BACKGRCOL);
              GotoXY(58+IX1,22); Write('Il giorno:');
              TextColor(MSGCOLOR3); TextBackground(COLORBOX1);
              GotoXY(58+IX1,23); Write(Copy(item.data+Repl(' ',MAXLENSTR),1,
                                                             MAXLENSTR));
              TextColor(MSGCOLOR1); TextBackground(BACKGRCOL);
              ShowCursor;
              TextColor(INPUTCOL); TextBackground(BACKGRCOL);
              ClearInput; GotoXY(64,5);
              Write(cur:2,' / ',tot:2);
              Mouse_Show;
              GetViewCommand(tp);
              CASE tp OF
                   FIRST : BEGIN Reset(stream); Read(stream,item);
                                 cur := 1; ArrayToMatrix(item.config,board);
                           END;
                   LAST  : BEGIN Seek(stream,tot-1); Read(stream,item);
                                 cur := tot; ArrayToMatrix(item.config,board);
                           END;
                   PREV  : IF cur > 1 THEN BEGIN
                              Seek(stream, cur-2); Read(stream,item); cur := cur-1;
                              ArrayToMatrix(item.config,board);
                           END ELSE Beep(110,1);
                   SUC   : IF not EOF(stream) THEN BEGIN
                              Read(stream,item); Inc(cur);
                              ArrayToMatrix(item.config,board);
                           END ELSE Beep(110,1);
                   PR    : PrintBoard(board,item.nome,item.data);
                   PRALL : BEGIN Reset(stream);
                                 WHILE not EOF(stream) DO BEGIN
                                       Read(stream,item);
                                       ArrayToMatrix(item.config,board);
                                       PrintBoard(board,item.nome,item.data);
                                 END;
                                 Seek(stream,cur-1); Read(stream,item);
                                 ArrayToMatrix(item.config,board);
                           END;
                   CLALL : BEGIN InitBoard(board);
                                 Erase(stream);
                                 tp := QUIT2;
                                 Mouse_Hide;
                                 Refresh(board);
                                 TextColor(INPUTCOL); TextBackground(BACKGRCOL);
                                 ClearInput; GotoXY(63,5);
                                 Flash(True); Write('No soluzioni'); Flash(False);
                                 FullBox(58+IX1,19,80,23,BACKGRCOL);
                                 Mouse_Show;
                                 Beep(110,1);
                                 WaitForEvent;
                           END;
                   QUIT2 : Close(stream);
              END;
        UNTIL (tp = QUIT2);
     END ELSE BEGIN
        Mouse_Hide;
        GotoXY(63,5);
        Flash(True); Write('I/O Error #',iores); Flash(False);
        Mouse_Show;
        Beep(110,1);
        WaitForEvent;
     END;
     Mouse_Hide;
     HideCursor;
END;

PROCEDURE Esci;
VAR ch  : char;
    md  : byte;
    x,y : integer;
    kp  : boolean;
BEGIN
     Pulisci(16,23);
     GotoXY(01,18); Center(Red,'Sei sicuro di voler uscire?');
     GotoXY(37,20); WriteColor(White,'[] '); WriteColor(Black,'S');
     GotoXY(37,21); WriteColor(White,'[] '); WriteColor(Black,'No');
     ch := ' ';
     md := 0;
     Mouse_Show;
     IF Mouse_Exists THEN REPEAT UNTIL Mouse_Down = 0;
     REPEAT
           REPEAT
                 kp := KeyPressed;
                 IF Mouse_Exists THEN md := Mouse_Down;
           UNTIL kp or (md <> 0);
           IF Mouse_Exists and (md <> 0) THEN BEGIN
              Mouse_GetPos(x,y);
              IF x in [37..42] THEN BEGIN
                 IF y = 20 THEN ch := 'S';
                 IF y = 21 THEN ch := 'N';
              END;
           END;
           IF kp THEN ch := UpCase(ReadKey);
     UNTIL Pos(ch,'S1N0'#27) <> 0;
     CASE ch OF
          'S','1'     :  scelta := 3;
          'N','0',#27 :  scelta := -1;
     END;
     Mouse_Hide;
END;

PROCEDURE ExitScreen;
BEGIN
     TextColor(LightGray);
     TextBackground(Black);
     ClrScr;
END;

PROCEDURE StartGame(var board:Tboard);
TYPE redotype = RECORD  avail : boolean;
                        cx,cy : coord;
                END;
     undotype = RECORD  avail  : boolean;
                        matrix : Tboard;
                END;
VAR x,y         : coord;
    count,
    prevcount   : word;
    item,itmp   : entry;
    exc         : word;
    d1,d2,d3,d4 : word;
    s1,s2       : string[4];
    s3          : string[8];
    stream      : Tstream;
    trovato     : boolean;
    i           : byte;
    strnum      : string[3];
    iores       : integer;
    ch          : char;
    tp          : cmdtype;
    xredo       : redotype;
    xundo       : undotype;
    cleared     : boolean;
BEGIN
     InitBoard(board);
     xundo.avail := False;
     xredo.avail := False;
     cleared := False;
     DrawBoard;
     DrawPlayCommands;
     count := 0; prevcount := 0;
     TextColor(INPUTCOL); TextBackground(BACKGRCOL);
     GotoXY(64,5); Write('    ');
     Mouse_Show;
     ShowCursor;
     REPEAT
           GotoXY(64,5);
           GetPlayCommand(tp,x,y);
           IF tp = CELL THEN BEGIN
              GotoXY(64,5);
              TextColor(INPUTCOL);
              Mouse_Hide; Write(y:0,'-',x:0); Mouse_Show;
              IF Allowed(board,x,y) THEN BEGIN
                 cleared := False;
                 xundo.avail  := True;
                 xundo.matrix := board;
                 xredo.avail  := False;
                 xredo.cx := x; xredo.cy := y;
                 PutPiece(board,x,y);
                 Inc(count);
                 item.config[y] := chr(x);
                 Refresh(board);
(****************************************************)
                 IF (count < 8) and (CountAvailable(board) = 0) THEN BEGIN
                   DisplayMsg(' * ATTENZIONE *','E'' impossibile','continuare');
                   Beep(220,1);
                 END ELSE IF CountAvailable(board) < (8-count) THEN BEGIN
                   DisplayMsg(' * ATTENZIONE *','E'' impossibile','vincere');
                   Beep(220,1);
                 END;
(****************************************************)
              END ELSE BEGIN
                 DisplayMsg('   * ERRORE *','Cella non con-','sentita');
                 Beep(110,1);
              END;
           END ELSE IF tp = UNDO THEN BEGIN
               ClearInput;
               IF xundo.avail THEN BEGIN
                  IF cleared THEN count := prevcount ELSE Dec(count);
                  xundo.avail := False;
                  xredo.avail := not cleared;
                  cleared     := False;
                  board := xundo.matrix;
                  Refresh(board);
                  DisplayMsg('    * UNDO *','Undo effettuato','');
               END ELSE BEGIN
                  DisplayMsg('   * ERRORE *','Undo non pos-','sibile');
                  Beep(110,1);
               END;
           END ELSE IF tp = REDO THEN BEGIN
               ClearInput;
               IF xredo.avail THEN BEGIN
                  xredo.avail  := False;
                  xundo.avail  := True;
                  xundo.matrix := board;
                  PutPiece(board,xredo.cx,xredo.cy);
                  Inc(count);
                  Refresh(board);
                  DisplayMsg('    * REDO *','Redo effettuato','');
               END ELSE BEGIN
                  DisplayMsg('   * ERRORE *','Redo non pos-','sibile');
                  Beep(110,1);
               END;
           END ELSE IF tp = CLEAR THEN BEGIN
               xredo.avail  := False;
               xundo.avail  := True;
               xundo.matrix := board;
               cleared      := True;
               InitBoard(board);
               Refresh(board);
               ClearInput;
               prevcount := count;
               count := 0;
               TextColor(INPUTCOL);
               Mouse_Hide; Write('    '); Mouse_Show; GotoXY(64,5);
               DisplayMsg('   * CLEAR *','La scacchiera ','stata ripulita');
               Beep(220,1);
           END;
     UNTIL (count = 8) or (tp = QUIT);
     HideCursor;
     IF (tp <> QUIT) THEN BEGIN
        GetDate(d3,d2,d1,d4);
        s1 := '00'+itoa(d1);
        s2 := '00'+itoa(d2);
        s3 := '0000'+itoa(d3);
        s1 := COPY(s1,Length(s1)-1,2);
        s2 := COPY(s2,Length(s2)-1,2);
        s3 := COPY(s3,Length(s3)-3,4);
        item.data := s1+'/'+s2+'/'+s3;
        Assign(stream, ExeDir+'8REGINE.DAT');
        {$I-}
        Reset(stream);
        {$I+}
        iores := IOResult;
        Mouse_Hide;
        IF iores = 2 THEN BEGIN { File Not Found }
           DisplayMsg(' * Hai vinto *','!Nuova soluzione','E'' la N.1');
           TextColor(MSGCOLOR1); TextBackground(BACKGRCOL);
           GotoXY(58+IX1,21); Write('Soluz. trovata il');
           TextColor(MSGCOLOR3); TextBackground(COLORBOX1);
           GotoXY(58+IX1,22); Write(Copy(item.data+Repl(' ',MAXLENSTR),1,
                                                          MAXLENSTR));
           TextColor(MSGCOLOR1); TextBackground(BACKGRCOL);
           GotoXY(58+IX1,18); Write('Scrivi il tuo nome');
           REPEAT
                 item.nome := InputStr(58+IX1,19,MAXLENSTR,MAXLENSTR,isSTART,
                                  [#32..#127], '',COLORBOX1,MSGCOLOR3,exc);
           UNTIL item.nome <> '';
           FOR i := 1 TO Length(item.nome) DO item.nome[i] := UpCase(item.nome[i]);
           TextColor(MSGCOLOR3); TextBackground(COLORBOX1); GotoXY(58+IX1,19);
           Write(Copy(item.nome+Repl(' ',MAXLENSTR),1,MAXLENSTR));
           TextBackground(BACKGRCOL);
           ReWrite(stream);
           Write(stream, item);
           Close(stream);
        END ELSE IF iores = 0 THEN BEGIN { Esiste il database-soluzioni }
           trovato := False;
           count := 0;
           WHILE (not Eof(stream)) and (not trovato) DO BEGIN
                 Inc(count);
                 Read(stream, itmp);
                 IF (itmp.config = item.config) THEN trovato := True;
           END;
           IF trovato THEN BEGIN { Soluzione presente }
              Close(stream);
              Str(count:0,strnum);
              DisplayMsg(' * Hai vinto *','!Soluz. presente','E'' la N.'+strnum);
              TextColor(MSGCOLOR1);
              GotoXY(58+IX1,18); Write('Trovata da:');
              TextColor(MSGCOLOR3); TextBackground(COLORBOX1);
              GotoXY(58+IX1,19); Write(Copy(itmp.nome+Repl(' ',MAXLENSTR),1,
                                                             MAXLENSTR));
              TextColor(MSGCOLOR1); TextBackground(BACKGRCOL);
              GotoXY(58+IX1,21); Write('Il giorno:');
              TextColor(MSGCOLOR3); TextBackground(COLORBOX1);
              GotoXY(58+IX1,22); Write(Copy(itmp.data+Repl(' ',MAXLENSTR),1,
                                                             MAXLENSTR));
              TextColor(MSGCOLOR1); TextBackground(BACKGRCOL);
           END ELSE BEGIN { Nuova Soluzione }
              Str(count+1:0,strnum);
              DisplayMsg(' * Hai vinto *','!Nuova soluzione','E'' la N.'+strnum);
              TextColor(MSGCOLOR1); TextBackground(BACKGRCOL);
              GotoXY(58+IX1,21); Write('Soluz. trovata il');
              TextColor(MSGCOLOR3); TextBackground(COLORBOX1);
              GotoXY(58+IX1,22); Write(Copy(item.data+Repl(' ',MAXLENSTR),1,
                                                             MAXLENSTR));
              TextColor(MSGCOLOR1); TextBackground(BACKGRCOL);
              GotoXY(58+IX1,18); Write('Scrivi il tuo nome');
              REPEAT
                 item.nome := InputStr(58+IX1,19,MAXLENSTR,MAXLENSTR,isSTART,
                                  [#32..#127], '',COLORBOX1,MSGCOLOR3,exc);
              UNTIL item.nome <> '';
              FOR i := 1 TO Length(item.nome) DO item.nome[i] := UpCase(item.nome[i]);
              TextColor(MSGCOLOR3); TextBackground(COLORBOX1); GotoXY(58+IX1,19);
              Write(Copy(item.nome+Repl(' ',MAXLENSTR),1,MAXLENSTR));
              TextBackground(BACKGRCOL);
              TextColor(MSGCOLOR1);
              Write(stream,item);
              Close(stream);
           END;
        END ELSE BEGIN { IOResult not in [0,2] cioe' I/O ERROR }
           Str(iores,strnum);
           DisplayMsg('Save: I/O','Error #'+strnum,'');
        END;
        Mouse_Show;
        WaitForEvent;
     END;
     Mouse_Hide;
     BorderColor(Black);
     TextBackground(LightGray);
     TextColor(Black);
END;

BEGIN    { Main Program }
     HideCursor;
     Initialize;
     IntroScreen; scelta := -1;
     REPEAT
           IF scelta = -1 THEN Pulisci(16,23) ELSE IntroScreen;
           SelectionScreen;
           CASE scelta OF
                1 : StartGame(board);
                2 : ShowArchive;
                3 : Esci;
           END;
     UNTIL (scelta = 3);
     ExitScreen;
     ShowCursor;
END.