UNIT UtilScr;

INTERFACE

USES CRT,DOS;

TYPE charset_utilscr = SET of char;

CONST isNOTH     = 0;
      isOK       = 1;
      isESC      = 2;
      isTAB      = 3;
      isSHTAB    = 4;

      isSTART    = 10;
      isEND      = 11;

      cdSINISTRA = -75;
      cdDESTRA   = -77;
      cdSU       = -72;
      cdGIU      = -80;

FUNCTION  GetCursor:word;
PROCEDURE SetCursor(newcursor:word);
PROCEDURE HideCursor;
PROCEDURE ShowCursor;
PROCEDURE SaveScreen(x1,y1,x2,y2:byte;var schermo:ARRAY of byte);
PROCEDURE RestScreen(x1,y1,x2,y2:byte;schermo:ARRAY of byte);
PROCEDURE BorderColor(col:byte);
PROCEDURE Flash(flag:boolean);
FUNCTION  GetKey:integer;
FUNCTION  InputStr(x,y,len,lim:byte; initpos:word; okchar:charset_utilscr;
                   default:string; backcol,textcol:byte; var exc:word):string;

IMPLEMENTATION

CONST cursore_on:word=0;

FUNCTION GetCursor;
VAR
   Reg : Registers;
BEGIN
     Reg.AH := 3;
     Reg.BH := 0;
     Intr($10, Reg);
     GetCursor := Reg.CX;
END;

PROCEDURE SetCursor(newcursor:word);
VAR
  Reg : Registers;
BEGIN
    Reg.AH := 1;
    Reg.BH := 0;
    Reg.CX := newcursor;
    Intr($10, Reg);
END;

PROCEDURE HideCursor;
BEGIN
     IF GetCursor <> $2000 THEN BEGIN
        cursore_on := GetCursor;
        SetCursor($2000);
     END;
END;

PROCEDURE ShowCursor;
BEGIN
     IF (cursore_on <> 0) and (cursore_on <> $2000) THEN
        SetCursor(cursore_on);
END;

PROCEDURE SaveScreen(x1,y1,x2,y2:byte;var schermo:ARRAY of byte);
VAR regs        : registers;
    cx,cy,wx,wy : byte;
    t           : integer;
    curs        : word;
BEGIN
     IF  (x1 in [1..80]) and (y1 in [1..25])
     and (x2 in [1..80]) and (y2 in [1..25]) THEN BEGIN
         curs := GetCursor;
         HideCursor;
         wx := WhereX; wy := WhereY;
         IF x1 > x2 THEN BEGIN
            t  := x1;
            x1 := x2;
            x2 := t;
         END;
         IF y1 > y2 THEN BEGIN
            t  := y1;
            y1 := y2;
            y2 := t;
         END;
         t := Low(schermo);
         FOR cy := y1 TO y2 DO
             FOR cx := x1 TO x2 DO
                 IF t+1 <= High(schermo) THEN BEGIN
                    GotoXY(cx,cy);
                    regs.AH := $08;
                    regs.BH := $00;
                    Intr($10,regs);
                    schermo[t+0] := regs.AL;
                    schermo[t+1] := regs.AH;
                    Inc(t,2)
                 END;
         SetCursor(curs);
         GotoXY(wx,wy);
     END;
END;

PROCEDURE RestScreen(x1,y1,x2,y2:byte;schermo:ARRAY of byte);
VAR regs        : registers;
    cx,cy,wx,wy : byte;
    t           : integer;
    curs        : word;
BEGIN
     IF  (x1 in [1..80]) and (y1 in [1..25])
     and (x2 in [1..80]) and (y2 in [1..25]) THEN BEGIN
         curs := GetCursor;
         HideCursor;
         wx := WhereX; wy := WhereY;
         IF x1 > x2 THEN BEGIN
            t  := x1;
            x1 := x2;
            x2 := t;
         END;
         IF y1 > y2 THEN BEGIN
            t  := y1;
            y1 := y2;
            y2 := t;
         END;
         t := Low(schermo);
         FOR cy := y1 TO y2 DO
             FOR cx := x1 TO x2 DO
                 IF t+1 <= High(schermo) THEN BEGIN
                    GotoXY(cx,cy);
                    regs.AH := $09; regs.AL := schermo[t+0];
                    regs.BH := $00; regs.BL := schermo[t+1];
                    regs.CX := $01;
                    Intr($10,regs);
                    Inc(t,2);
                 END;
         SetCursor(curs);
         GotoXY(wx,wy);
     END;
END;

PROCEDURE BorderColor(col:byte);
VAR regs : Registers;
BEGIN
     regs.AX := $1001;
     regs.BH := col mod $40;
     Intr($10,regs);
END;

PROCEDURE Flash(flag:boolean);
BEGIN
     IF flag THEN
        TextAttr := TextAttr or  128
     ELSE
        TextAttr := TextAttr and 127;
END;

FUNCTION GetKey:integer;
VAR ch  : char;
    ris : integer;
BEGIN
     ch := ReadKey;
     IF ch <> #0 THEN
        ris := ord(ch)
     ELSE BEGIN
        ch := ReadKey;
        ris := -ord(ch);
     END;
     GetKey := ris;
END;

FUNCTION InputStr(x,y,len,lim:byte; initpos:word; okchar:charset_utilscr;
                  default:string; backcol,textcol:byte; var exc:word):string;
VAR s          : string;
    indice,j,p : byte;  { p  la posizione del cursore nella stringa }
    key        : integer;
    curs       : word;
    tattr      : byte;
BEGIN
     curs := GetCursor;
     tattr := TextAttr;
     exc := isNOTH;
     HideCursor;
     IF lim = 0 THEN lim := 255;
     IF Length(default) > lim THEN default[0] := chr(lim);
     s := default;
     TextColor(textcol);
     TextBackground(backcol);
     IF initpos = isSTART THEN BEGIN
        indice := 0;
        p := 1;
     END ELSE BEGIN
        p := Length(s)+1;
        IF Length(s) < len THEN
           indice := 0
        ELSE
        indice := Length(s)-len+1;
     END;
     REPEAT
           GotoXY(x,y);
           FOR j := 1 TO len DO
               IF (indice+j <= Length(s)) THEN
                  Write(s[indice+j])
               ELSE
                  Write(' ');
           GotoXY(x+p-indice-1,y);
           ShowCursor;
           key := GetKey;
           HideCursor;
           CASE key OF
                32..255 : IF ((chr(key) in okchar) and (Length(s) < lim)) THEN BEGIN
                             s := s+' ';
                             FOR j := Length(s)-1 DOWNTO p DO s[j+1] := s[j];
                             s[p] := chr(key);
                             Inc(p);
                             IF p-indice > len THEN Inc(indice);
                          END;
 { Freccia Sx } -75     : IF p > 1 THEN BEGIN
                             Dec(p);
                             IF p <= indice THEN Dec(indice);
                          END;
 { Freccia Dx } -77     : IF p <= Length(s) THEN BEGIN
                             Inc(p);
                             IF p-indice > len THEN Inc(indice);
                          END;
 { Backspace }   8      : IF ((Length(s) > 0) and (p > 1)) THEN BEGIN
                             FOR j := p TO Length(s) DO s[j-1] := s[j];
                             Dec(s[0]);  { Decrementa di 1 la lung. di s }
                             Dec(p);
                             IF p <= indice THEN Dec(indice);
                          END;
 { Canc (Del) }-83      : IF ((Length(s) > 0) and (p <= Length(s))) THEN BEGIN
                             FOR j := p TO Length(s)-1 DO s[j] := s[j+1];
                             Dec(s[0]); { Decrementa di 1 la lungh. di s }
                          END;
 { Home }      -71      : BEGIN
                               indice := 0;
                               p := 1;
                          END;
 { End }       -79      : BEGIN
                               p := Length(s)+1;
                               IF Length(s) < len THEN
                                  indice := 0
                               ELSE
                                  indice := Length(s)-len+1;
                          END;
 { Ctrl-X }     24      : BEGIN
                               s := '';
                               indice := 0;
                               p := 1;
                          END;
 { Return }     13      : BEGIN
                               InputStr := s;
                               exc := isOK;
                          END;
 { ESC    }     27      : BEGIN
                               InputStr := default;
                               exc := isESC;
                          END;
 { TAB    }      9      : BEGIN
                               InputStr := s;
                               exc := isTAB;
                          END;
 { Shift TAB } -15      : BEGIN
                               InputStr := s;
                               exc := isSHTAB;
                          END;
           END;
     UNTIL exc <> isNOTH;
     TextAttr := tattr;
     SetCursor(curs);
END;

END.